/* gmpc-profiles.c generated by valac 0.56.18, the Vala compiler
 * generated from gmpc-profiles.vala, do not modify */

/* Gnome Music Player Client (GMPC)
 * Copyright (C) 2004-2012 Qball Cow <qball@gmpclient.org>
 * Copyright (C) 2012 Quentin "Sardem FF7" Glidic
 * Project homepage: http://gmpclient.org/

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <config.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>
#include "gmpc-extras.h"
#include <config1.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <playlist3-messages.h>
#include <plugin.h>

#define some_unique_name_prfs VERSION
#define GMPC_PROFILES_LOG_DOMAIN "Profiles"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define GMPC_TYPE_PROFILE (gmpc_profile_get_type ())
#define GMPC_PROFILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GMPC_TYPE_PROFILE, GmpcProfile))
#define GMPC_PROFILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GMPC_TYPE_PROFILE, GmpcProfileClass))
#define GMPC_IS_PROFILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GMPC_TYPE_PROFILE))
#define GMPC_IS_PROFILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GMPC_TYPE_PROFILE))
#define GMPC_PROFILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GMPC_TYPE_PROFILE, GmpcProfileClass))

typedef struct _GmpcProfile GmpcProfile;
typedef struct _GmpcProfileClass GmpcProfileClass;
typedef struct _GmpcProfilePrivate GmpcProfilePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _GmpcParamSpecProfile GmpcParamSpecProfile;
enum  {
	GMPC_PROFILES_0_PROPERTY,
	GMPC_PROFILES_NUM_PROPERTIES
};
static GParamSpec* gmpc_profiles_properties[GMPC_PROFILES_NUM_PROPERTIES];
#define _cfg_close0(var) ((var == NULL) ? NULL : (var = (cfg_close (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gmpc_profile_unref0(var) ((var == NULL) ? NULL : (var = (gmpc_profile_unref (var), NULL)))
#define _cfg_free_multiple0(var) ((var == NULL) ? NULL : (var = (cfg_free_multiple (var), NULL)))
typedef struct _Block7Data Block7Data;
enum  {
	GMPC_PROFILES_CHANGED_SIGNAL,
	GMPC_PROFILES_PROFILE_CHANGED_SIGNAL,
	GMPC_PROFILES_NUM_SIGNALS
};
static guint gmpc_profiles_signals[GMPC_PROFILES_NUM_SIGNALS] = {0};

struct _GmpcProfile {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GmpcProfilePrivate * priv;
	gchar* id;
	gchar* name;
	gchar* hostname;
	gint port;
	gboolean do_auth;
	gchar* password;
	gchar* music_directory;
	gint db_update_time;
};

struct _GmpcProfileClass {
	GTypeClass parent_class;
	void (*finalize) (GmpcProfile *self);
};

struct _GmpcParamSpecProfile {
	GParamSpec parent_instance;
};

struct _GmpcProfilesPrivate {
	config_obj* profiles;
	GHashTable* list;
};

struct _Block7Data {
	int _ref_count_;
	GmpcProfiles* self;
	gchar* name;
};

static gpointer gmpc_profile_parent_class = NULL;
static gint GmpcProfiles_private_offset;
static gpointer gmpc_profiles_parent_class = NULL;

VALA_EXTERN gpointer gmpc_profile_ref (gpointer instance);
VALA_EXTERN void gmpc_profile_unref (gpointer instance);
VALA_EXTERN GParamSpec* gmpc_param_spec_profile (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void gmpc_value_set_profile (GValue* value,
                             gpointer v_object);
VALA_EXTERN void gmpc_value_take_profile (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer gmpc_value_get_profile (const GValue* value);
VALA_EXTERN GType gmpc_profile_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GmpcProfile* gmpc_profile_new (void);
VALA_EXTERN GmpcProfile* gmpc_profile_construct (GType object_type);
static void gmpc_profile_finalize (GmpcProfile * obj);
static GType gmpc_profile_get_type_once (void);
static void gmpc_profiles_connect_to_profile_button (GmpcProfiles* self,
                                              GtkButton* button);
static void gmpc_profiles_changed_internal (GmpcProfiles* self,
                                     GmpcProfilesAction changed,
                                     GmpcProfilesColumn col,
                                     const gchar* id);
static void _g_free_gdestroy_notify (void* data);
static void _gmpc_profiles_connect_to_profile_button_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self);
static void gmpc_profiles_add_default (GmpcProfiles* self);
static void gmpc_profiles_load_from_config (GmpcProfiles* self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static gboolean __lambda85_ (Block7Data* _data7_,
                      const gchar* id,
                      GmpcProfile* prof);
static gboolean ___lambda85__ghr_func (gconstpointer key,
                                gconstpointer value,
                                gpointer self);
static void g_cclosure_user_marshal_VOID__INT_INT_STRING (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static GObject * gmpc_profiles_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void _g_free0_ (gpointer var);
static void _gmpc_profile_unref0_ (gpointer var);
static void gmpc_profiles_finalize (GObject * obj);
static GType gmpc_profiles_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

GmpcProfile*
gmpc_profile_construct (GType object_type)
{
	GmpcProfile* self = NULL;
#line 25 "Widgets/gmpc-profiles.vala"
	self = (GmpcProfile*) g_type_create_instance (object_type);
#line 25 "Widgets/gmpc-profiles.vala"
	return self;
#line 177 "gmpc-profiles.c"
}

GmpcProfile*
gmpc_profile_new (void)
{
#line 25 "Widgets/gmpc-profiles.vala"
	return gmpc_profile_construct (GMPC_TYPE_PROFILE);
#line 185 "gmpc-profiles.c"
}

static void
gmpc_value_profile_init (GValue* value)
{
#line 25 "Widgets/gmpc-profiles.vala"
	value->data[0].v_pointer = NULL;
#line 193 "gmpc-profiles.c"
}

static void
gmpc_value_profile_free_value (GValue* value)
{
#line 25 "Widgets/gmpc-profiles.vala"
	if (value->data[0].v_pointer) {
#line 25 "Widgets/gmpc-profiles.vala"
		gmpc_profile_unref (value->data[0].v_pointer);
#line 203 "gmpc-profiles.c"
	}
}

static void
gmpc_value_profile_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 25 "Widgets/gmpc-profiles.vala"
	if (src_value->data[0].v_pointer) {
#line 25 "Widgets/gmpc-profiles.vala"
		dest_value->data[0].v_pointer = gmpc_profile_ref (src_value->data[0].v_pointer);
#line 215 "gmpc-profiles.c"
	} else {
#line 25 "Widgets/gmpc-profiles.vala"
		dest_value->data[0].v_pointer = NULL;
#line 219 "gmpc-profiles.c"
	}
}

static gpointer
gmpc_value_profile_peek_pointer (const GValue* value)
{
#line 25 "Widgets/gmpc-profiles.vala"
	return value->data[0].v_pointer;
#line 228 "gmpc-profiles.c"
}

static gchar*
gmpc_value_profile_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 25 "Widgets/gmpc-profiles.vala"
	if (collect_values[0].v_pointer) {
#line 239 "gmpc-profiles.c"
		GmpcProfile * object;
		object = collect_values[0].v_pointer;
#line 25 "Widgets/gmpc-profiles.vala"
		if (object->parent_instance.g_class == NULL) {
#line 25 "Widgets/gmpc-profiles.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 246 "gmpc-profiles.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 25 "Widgets/gmpc-profiles.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 250 "gmpc-profiles.c"
		}
#line 25 "Widgets/gmpc-profiles.vala"
		value->data[0].v_pointer = gmpc_profile_ref (object);
#line 254 "gmpc-profiles.c"
	} else {
#line 25 "Widgets/gmpc-profiles.vala"
		value->data[0].v_pointer = NULL;
#line 258 "gmpc-profiles.c"
	}
#line 25 "Widgets/gmpc-profiles.vala"
	return NULL;
#line 262 "gmpc-profiles.c"
}

static gchar*
gmpc_value_profile_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	GmpcProfile ** object_p;
	object_p = collect_values[0].v_pointer;
#line 25 "Widgets/gmpc-profiles.vala"
	if (!object_p) {
#line 25 "Widgets/gmpc-profiles.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 277 "gmpc-profiles.c"
	}
#line 25 "Widgets/gmpc-profiles.vala"
	if (!value->data[0].v_pointer) {
#line 25 "Widgets/gmpc-profiles.vala"
		*object_p = NULL;
#line 283 "gmpc-profiles.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 25 "Widgets/gmpc-profiles.vala"
		*object_p = value->data[0].v_pointer;
#line 287 "gmpc-profiles.c"
	} else {
#line 25 "Widgets/gmpc-profiles.vala"
		*object_p = gmpc_profile_ref (value->data[0].v_pointer);
#line 291 "gmpc-profiles.c"
	}
#line 25 "Widgets/gmpc-profiles.vala"
	return NULL;
#line 295 "gmpc-profiles.c"
}

GParamSpec*
gmpc_param_spec_profile (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	GmpcParamSpecProfile* spec;
#line 25 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GMPC_TYPE_PROFILE), NULL);
#line 25 "Widgets/gmpc-profiles.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 25 "Widgets/gmpc-profiles.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 25 "Widgets/gmpc-profiles.vala"
	return G_PARAM_SPEC (spec);
#line 314 "gmpc-profiles.c"
}

gpointer
gmpc_value_get_profile (const GValue* value)
{
#line 25 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GMPC_TYPE_PROFILE), NULL);
#line 25 "Widgets/gmpc-profiles.vala"
	return value->data[0].v_pointer;
#line 324 "gmpc-profiles.c"
}

void
gmpc_value_set_profile (GValue* value,
                        gpointer v_object)
{
	GmpcProfile * old;
#line 25 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GMPC_TYPE_PROFILE));
#line 25 "Widgets/gmpc-profiles.vala"
	old = value->data[0].v_pointer;
#line 25 "Widgets/gmpc-profiles.vala"
	if (v_object) {
#line 25 "Widgets/gmpc-profiles.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GMPC_TYPE_PROFILE));
#line 25 "Widgets/gmpc-profiles.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "Widgets/gmpc-profiles.vala"
		value->data[0].v_pointer = v_object;
#line 25 "Widgets/gmpc-profiles.vala"
		gmpc_profile_ref (value->data[0].v_pointer);
#line 346 "gmpc-profiles.c"
	} else {
#line 25 "Widgets/gmpc-profiles.vala"
		value->data[0].v_pointer = NULL;
#line 350 "gmpc-profiles.c"
	}
#line 25 "Widgets/gmpc-profiles.vala"
	if (old) {
#line 25 "Widgets/gmpc-profiles.vala"
		gmpc_profile_unref (old);
#line 356 "gmpc-profiles.c"
	}
}

void
gmpc_value_take_profile (GValue* value,
                         gpointer v_object)
{
	GmpcProfile * old;
#line 25 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GMPC_TYPE_PROFILE));
#line 25 "Widgets/gmpc-profiles.vala"
	old = value->data[0].v_pointer;
#line 25 "Widgets/gmpc-profiles.vala"
	if (v_object) {
#line 25 "Widgets/gmpc-profiles.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GMPC_TYPE_PROFILE));
#line 25 "Widgets/gmpc-profiles.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "Widgets/gmpc-profiles.vala"
		value->data[0].v_pointer = v_object;
#line 377 "gmpc-profiles.c"
	} else {
#line 25 "Widgets/gmpc-profiles.vala"
		value->data[0].v_pointer = NULL;
#line 381 "gmpc-profiles.c"
	}
#line 25 "Widgets/gmpc-profiles.vala"
	if (old) {
#line 25 "Widgets/gmpc-profiles.vala"
		gmpc_profile_unref (old);
#line 387 "gmpc-profiles.c"
	}
}

static void
gmpc_profile_class_init (GmpcProfileClass * klass,
                         gpointer klass_data)
{
#line 25 "Widgets/gmpc-profiles.vala"
	gmpc_profile_parent_class = g_type_class_peek_parent (klass);
#line 25 "Widgets/gmpc-profiles.vala"
	((GmpcProfileClass *) klass)->finalize = gmpc_profile_finalize;
#line 399 "gmpc-profiles.c"
}

static void
gmpc_profile_instance_init (GmpcProfile * self,
                            gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 27 "Widgets/gmpc-profiles.vala"
	self->id = NULL;
#line 28 "Widgets/gmpc-profiles.vala"
	self->name = NULL;
#line 29 "Widgets/gmpc-profiles.vala"
	_tmp0_ = g_strdup ("localhost");
#line 29 "Widgets/gmpc-profiles.vala"
	self->hostname = _tmp0_;
#line 30 "Widgets/gmpc-profiles.vala"
	self->port = 6600;
#line 31 "Widgets/gmpc-profiles.vala"
	self->do_auth = FALSE;
#line 32 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_strdup ("");
#line 32 "Widgets/gmpc-profiles.vala"
	self->password = _tmp1_;
#line 33 "Widgets/gmpc-profiles.vala"
	self->music_directory = NULL;
#line 34 "Widgets/gmpc-profiles.vala"
	self->db_update_time = 0;
#line 25 "Widgets/gmpc-profiles.vala"
	self->ref_count = 1;
#line 430 "gmpc-profiles.c"
}

static void
gmpc_profile_finalize (GmpcProfile * obj)
{
	GmpcProfile * self;
#line 25 "Widgets/gmpc-profiles.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GMPC_TYPE_PROFILE, GmpcProfile);
#line 25 "Widgets/gmpc-profiles.vala"
	g_signal_handlers_destroy (self);
#line 27 "Widgets/gmpc-profiles.vala"
	_g_free0 (self->id);
#line 28 "Widgets/gmpc-profiles.vala"
	_g_free0 (self->name);
#line 29 "Widgets/gmpc-profiles.vala"
	_g_free0 (self->hostname);
#line 32 "Widgets/gmpc-profiles.vala"
	_g_free0 (self->password);
#line 33 "Widgets/gmpc-profiles.vala"
	_g_free0 (self->music_directory);
#line 451 "gmpc-profiles.c"
}

static GType
gmpc_profile_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { gmpc_value_profile_init, gmpc_value_profile_free_value, gmpc_value_profile_copy_value, gmpc_value_profile_peek_pointer, "p", gmpc_value_profile_collect_value, "p", gmpc_value_profile_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GmpcProfileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gmpc_profile_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GmpcProfile), 0, (GInstanceInitFunc) gmpc_profile_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType gmpc_profile_type_id;
	gmpc_profile_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GmpcProfile", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return gmpc_profile_type_id;
}

GType
gmpc_profile_get_type (void)
{
	static volatile gsize gmpc_profile_type_id__once = 0;
	if (g_once_init_enter (&gmpc_profile_type_id__once)) {
		GType gmpc_profile_type_id;
		gmpc_profile_type_id = gmpc_profile_get_type_once ();
		g_once_init_leave (&gmpc_profile_type_id__once, gmpc_profile_type_id);
	}
	return gmpc_profile_type_id__once;
}

gpointer
gmpc_profile_ref (gpointer instance)
{
	GmpcProfile * self;
	self = instance;
#line 25 "Widgets/gmpc-profiles.vala"
	g_atomic_int_inc (&self->ref_count);
#line 25 "Widgets/gmpc-profiles.vala"
	return instance;
#line 486 "gmpc-profiles.c"
}

void
gmpc_profile_unref (gpointer instance)
{
	GmpcProfile * self;
	self = instance;
#line 25 "Widgets/gmpc-profiles.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 25 "Widgets/gmpc-profiles.vala"
		GMPC_PROFILE_GET_CLASS (self)->finalize (self);
#line 25 "Widgets/gmpc-profiles.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 500 "gmpc-profiles.c"
	}
}

static inline gpointer
gmpc_profiles_get_instance_private (GmpcProfiles* self)
{
	return G_STRUCT_MEMBER_P (self, GmpcProfiles_private_offset);
}

static GType
gmpc_profiles_action_get_type_once (void)
{
	static const GEnumValue values[] = {{GMPC_PROFILES_ACTION_ADDED, "GMPC_PROFILES_ACTION_ADDED", "added"}, {GMPC_PROFILES_ACTION_REMOVED, "GMPC_PROFILES_ACTION_REMOVED", "removed"}, {GMPC_PROFILES_ACTION_COL_CHANGED, "GMPC_PROFILES_ACTION_COL_CHANGED", "col-changed"}, {GMPC_PROFILES_ACTION_CURRENT, "GMPC_PROFILES_ACTION_CURRENT", "current"}, {0, NULL, NULL}};
	GType gmpc_profiles_action_type_id;
	gmpc_profiles_action_type_id = g_enum_register_static ("GmpcProfilesAction", values);
	return gmpc_profiles_action_type_id;
}

GType
gmpc_profiles_action_get_type (void)
{
	static volatile gsize gmpc_profiles_action_type_id__once = 0;
	if (g_once_init_enter (&gmpc_profiles_action_type_id__once)) {
		GType gmpc_profiles_action_type_id;
		gmpc_profiles_action_type_id = gmpc_profiles_action_get_type_once ();
		g_once_init_leave (&gmpc_profiles_action_type_id__once, gmpc_profiles_action_type_id);
	}
	return gmpc_profiles_action_type_id__once;
}

static GType
gmpc_profiles_column_get_type_once (void)
{
	static const GEnumValue values[] = {{GMPC_PROFILES_COLUMN_NAME, "GMPC_PROFILES_COLUMN_NAME", "name"}, {GMPC_PROFILES_COLUMN_HOSTNAME, "GMPC_PROFILES_COLUMN_HOSTNAME", "hostname"}, {GMPC_PROFILES_COLUMN_PORT, "GMPC_PROFILES_COLUMN_PORT", "port"}, {GMPC_PROFILES_COLUMN_DO_AUTH, "GMPC_PROFILES_COLUMN_DO_AUTH", "do-auth"}, {GMPC_PROFILES_COLUMN_PASSWORD, "GMPC_PROFILES_COLUMN_PASSWORD", "password"}, {GMPC_PROFILES_COLUMN_MUSIC_DIRECTORY, "GMPC_PROFILES_COLUMN_MUSIC_DIRECTORY", "music-directory"}, {GMPC_PROFILES_COLUMN_DB_UPDATE_TIME, "GMPC_PROFILES_COLUMN_DB_UPDATE_TIME", "db-update-time"}, {GMPC_PROFILES_COLUMN_NUM_COLS, "GMPC_PROFILES_COLUMN_NUM_COLS", "num-cols"}, {0, NULL, NULL}};
	GType gmpc_profiles_column_type_id;
	gmpc_profiles_column_type_id = g_enum_register_static ("GmpcProfilesColumn", values);
	return gmpc_profiles_column_type_id;
}

GType
gmpc_profiles_column_get_type (void)
{
	static volatile gsize gmpc_profiles_column_type_id__once = 0;
	if (g_once_init_enter (&gmpc_profiles_column_type_id__once)) {
		GType gmpc_profiles_column_type_id;
		gmpc_profiles_column_type_id = gmpc_profiles_column_get_type_once ();
		g_once_init_leave (&gmpc_profiles_column_type_id__once, gmpc_profiles_column_type_id);
	}
	return gmpc_profiles_column_type_id__once;
}

guint
gmpc_profiles_get_number_of_profiles (GmpcProfiles* self)
{
	GHashTable* _tmp0_;
	guint result;
#line 65 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 69 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 69 "Widgets/gmpc-profiles.vala"
	result = g_hash_table_size (_tmp0_);
#line 69 "Widgets/gmpc-profiles.vala"
	return result;
#line 565 "gmpc-profiles.c"
}

static void
gmpc_profiles_connect_to_profile_button (GmpcProfiles* self,
                                         GtkButton* button)
{
	gchar* id = NULL;
	gconstpointer _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 73 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (self != NULL);
#line 73 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (button != NULL);
#line 77 "Widgets/gmpc-profiles.vala"
	_tmp0_ = g_object_get_data ((GObject*) button, "profile-id");
#line 77 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
#line 77 "Widgets/gmpc-profiles.vala"
	id = _tmp1_;
#line 78 "Widgets/gmpc-profiles.vala"
	_tmp2_ = id;
#line 78 "Widgets/gmpc-profiles.vala"
	if (_tmp2_ != NULL) {
#line 590 "gmpc-profiles.c"
		const gchar* _tmp3_;
#line 80 "Widgets/gmpc-profiles.vala"
		_tmp3_ = id;
#line 80 "Widgets/gmpc-profiles.vala"
		gmpc_profiles_set_current (self, _tmp3_);
#line 81 "Widgets/gmpc-profiles.vala"
		disconnect_from_mpd ();
#line 82 "Widgets/gmpc-profiles.vala"
		connect_to_mpd ();
#line 600 "gmpc-profiles.c"
	}
#line 73 "Widgets/gmpc-profiles.vala"
	_g_free0 (id);
#line 604 "gmpc-profiles.c"
}

static void
_g_free_gdestroy_notify (void* data)
{
#line 97 "Widgets/gmpc-profiles.vala"
	g_free (data);
#line 612 "gmpc-profiles.c"
}

static void
_gmpc_profiles_connect_to_profile_button_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self)
{
#line 98 "Widgets/gmpc-profiles.vala"
	gmpc_profiles_connect_to_profile_button ((GmpcProfiles*) self, _sender);
#line 621 "gmpc-profiles.c"
}

static void
gmpc_profiles_changed_internal (GmpcProfiles* self,
                                GmpcProfilesAction changed,
                                GmpcProfilesColumn col,
                                const gchar* id)
{
#line 87 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (self != NULL);
#line 87 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (id != NULL);
#line 90 "Widgets/gmpc-profiles.vala"
	switch (changed) {
#line 90 "Widgets/gmpc-profiles.vala"
		case GMPC_PROFILES_ACTION_ADDED:
#line 638 "gmpc-profiles.c"
		{
			GtkButton* connect_button = NULL;
			GtkButton* _tmp0_;
			gchar* message = NULL;
			const gchar* _tmp1_;
			gchar* _tmp2_;
			const gchar* _tmp3_;
			GtkButton* _tmp4_;
			GtkButton* _tmp5_;
			GtkButton* _tmp6_;
#line 93 "Widgets/gmpc-profiles.vala"
			_tmp0_ = (GtkButton*) gtk_button_new_from_stock (GTK_STOCK_CONNECT);
#line 93 "Widgets/gmpc-profiles.vala"
			g_object_ref_sink (_tmp0_);
#line 93 "Widgets/gmpc-profiles.vala"
			connect_button = _tmp0_;
#line 94 "Widgets/gmpc-profiles.vala"
			_tmp1_ = gmpc_profiles_get_name (self, id);
#line 94 "Widgets/gmpc-profiles.vala"
			_tmp2_ = g_markup_printf_escaped ("<b>%s:</b> '%s'", _ ("Added profile"), _tmp1_);
#line 94 "Widgets/gmpc-profiles.vala"
			message = _tmp2_;
#line 95 "Widgets/gmpc-profiles.vala"
			_tmp3_ = message;
#line 95 "Widgets/gmpc-profiles.vala"
			playlist3_show_error_message (_tmp3_, ERROR_INFO);
#line 97 "Widgets/gmpc-profiles.vala"
			_tmp4_ = connect_button;
#line 97 "Widgets/gmpc-profiles.vala"
			g_object_set_data_full ((GObject*) _tmp4_, "profile-id", id, _g_free_gdestroy_notify);
#line 98 "Widgets/gmpc-profiles.vala"
			_tmp5_ = connect_button;
#line 98 "Widgets/gmpc-profiles.vala"
			g_signal_connect_object (_tmp5_, "clicked", (GCallback) _gmpc_profiles_connect_to_profile_button_gtk_button_clicked, self, 0);
#line 99 "Widgets/gmpc-profiles.vala"
			_tmp6_ = connect_button;
#line 99 "Widgets/gmpc-profiles.vala"
			playlist3_error_add_widget ((GtkWidget*) _tmp6_);
#line 101 "Widgets/gmpc-profiles.vala"
			g_log (GMPC_PROFILES_LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gmpc-profiles.vala:101: Item %s added\n", id);
#line 102 "Widgets/gmpc-profiles.vala"
			_g_free0 (message);
#line 102 "Widgets/gmpc-profiles.vala"
			_g_object_unref0 (connect_button);
#line 102 "Widgets/gmpc-profiles.vala"
			break;
#line 685 "gmpc-profiles.c"
		}
#line 90 "Widgets/gmpc-profiles.vala"
		case GMPC_PROFILES_ACTION_REMOVED:
#line 689 "gmpc-profiles.c"
		{
#line 104 "Widgets/gmpc-profiles.vala"
			g_log (GMPC_PROFILES_LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gmpc-profiles.vala:104: Item %s removed\n", id);
#line 105 "Widgets/gmpc-profiles.vala"
			break;
#line 695 "gmpc-profiles.c"
		}
#line 90 "Widgets/gmpc-profiles.vala"
		case GMPC_PROFILES_ACTION_COL_CHANGED:
#line 699 "gmpc-profiles.c"
		{
#line 113 "Widgets/gmpc-profiles.vala"
			g_log (GMPC_PROFILES_LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gmpc-profiles.vala:113: Item %s changed col: %i\n", id, (gint) col);
#line 114 "Widgets/gmpc-profiles.vala"
			break;
#line 705 "gmpc-profiles.c"
		}
#line 90 "Widgets/gmpc-profiles.vala"
		case GMPC_PROFILES_ACTION_CURRENT:
#line 709 "gmpc-profiles.c"
		{
#line 116 "Widgets/gmpc-profiles.vala"
			break;
#line 713 "gmpc-profiles.c"
		}
		default:
#line 90 "Widgets/gmpc-profiles.vala"
		break;
#line 718 "gmpc-profiles.c"
	}
#line 118 "Widgets/gmpc-profiles.vala"
	g_signal_emit (self, gmpc_profiles_signals[GMPC_PROFILES_CHANGED_SIGNAL], 0, (gint) changed, (gint) col, id);
#line 722 "gmpc-profiles.c"
}

/**
         * Add default values
         */
static void
gmpc_profiles_add_default (GmpcProfiles* self)
{
	const config_obj* _tmp0_;
	const config_obj* _tmp1_;
	const config_obj* _tmp2_;
	const config_obj* _tmp3_;
	const config_obj* _tmp4_;
	const config_obj* _tmp5_;
	const config_obj* _tmp6_;
#line 149 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (self != NULL);
#line 153 "Widgets/gmpc-profiles.vala"
	_tmp0_ = config;
#line 153 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_string (_tmp0_, "connection", "currentprofile", "Default");
#line 154 "Widgets/gmpc-profiles.vala"
	_tmp1_ = self->priv->profiles;
#line 154 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_string (_tmp1_, "Default", "hostname", "localhost");
#line 155 "Widgets/gmpc-profiles.vala"
	_tmp2_ = self->priv->profiles;
#line 155 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_string (_tmp2_, "Default", "name", "Default");
#line 156 "Widgets/gmpc-profiles.vala"
	_tmp3_ = self->priv->profiles;
#line 156 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_string (_tmp3_, "Default", "password", "");
#line 157 "Widgets/gmpc-profiles.vala"
	_tmp4_ = self->priv->profiles;
#line 157 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_int (_tmp4_, "Default", "portnumber", 6600);
#line 158 "Widgets/gmpc-profiles.vala"
	_tmp5_ = self->priv->profiles;
#line 158 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_int (_tmp5_, "Default", "useauth", FALSE);
#line 159 "Widgets/gmpc-profiles.vala"
	_tmp6_ = self->priv->profiles;
#line 159 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_string (_tmp6_, "Default", "music directory", "");
#line 768 "gmpc-profiles.c"
}

static gpointer
_gmpc_profile_ref0 (gpointer self)
{
#line 181 "Widgets/gmpc-profiles.vala"
	return self ? gmpc_profile_ref (self) : NULL;
#line 776 "gmpc-profiles.c"
}

static void
gmpc_profiles_load_from_config (GmpcProfiles* self)
{
	conf_mult_obj* list = NULL;
	const config_obj* _tmp0_;
	conf_mult_obj* _tmp1_;
#line 162 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (self != NULL);
#line 166 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->profiles;
#line 166 "Widgets/gmpc-profiles.vala"
	_tmp1_ = cfg_get_class_list (_tmp0_);
#line 166 "Widgets/gmpc-profiles.vala"
	list = _tmp1_;
#line 793 "gmpc-profiles.c"
	{
		const conf_mult_obj* iter = NULL;
		const conf_mult_obj* _tmp2_;
#line 167 "Widgets/gmpc-profiles.vala"
		_tmp2_ = list;
#line 167 "Widgets/gmpc-profiles.vala"
		iter = _tmp2_;
#line 801 "gmpc-profiles.c"
		{
			gboolean _tmp3_ = FALSE;
#line 167 "Widgets/gmpc-profiles.vala"
			_tmp3_ = TRUE;
#line 167 "Widgets/gmpc-profiles.vala"
			while (TRUE) {
#line 808 "gmpc-profiles.c"
				const conf_mult_obj* _tmp6_;
				GmpcProfile* prof = NULL;
				GmpcProfile* _tmp7_;
				GmpcProfile* _tmp8_;
				const conf_mult_obj* _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				GmpcProfile* _tmp12_;
				const config_obj* _tmp13_;
				GmpcProfile* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				GmpcProfile* _tmp17_;
				const config_obj* _tmp18_;
				GmpcProfile* _tmp19_;
				const gchar* _tmp20_;
				gchar* _tmp21_;
				GmpcProfile* _tmp22_;
				const config_obj* _tmp23_;
				GmpcProfile* _tmp24_;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				GmpcProfile* _tmp27_;
				const config_obj* _tmp28_;
				GmpcProfile* _tmp29_;
				const gchar* _tmp30_;
				GmpcProfile* _tmp31_;
				const config_obj* _tmp32_;
				GmpcProfile* _tmp33_;
				const gchar* _tmp34_;
				GmpcProfile* _tmp35_;
				const config_obj* _tmp36_;
				GmpcProfile* _tmp37_;
				const gchar* _tmp38_;
				gchar* _tmp39_;
				GmpcProfile* _tmp40_;
				const config_obj* _tmp41_;
				GmpcProfile* _tmp42_;
				const gchar* _tmp43_;
				GHashTable* _tmp44_;
				GmpcProfile* _tmp45_;
				const gchar* _tmp46_;
				gchar* _tmp47_;
				GmpcProfile* _tmp48_;
				GmpcProfile* _tmp49_;
#line 167 "Widgets/gmpc-profiles.vala"
				if (!_tmp3_) {
#line 856 "gmpc-profiles.c"
					const conf_mult_obj* _tmp4_;
					const conf_mult_obj* _tmp5_;
#line 167 "Widgets/gmpc-profiles.vala"
					_tmp4_ = iter;
#line 167 "Widgets/gmpc-profiles.vala"
					_tmp5_ = _tmp4_->next;
#line 167 "Widgets/gmpc-profiles.vala"
					iter = _tmp5_;
#line 865 "gmpc-profiles.c"
				}
#line 167 "Widgets/gmpc-profiles.vala"
				_tmp3_ = FALSE;
#line 167 "Widgets/gmpc-profiles.vala"
				_tmp6_ = iter;
#line 167 "Widgets/gmpc-profiles.vala"
				if (!(_tmp6_ != NULL)) {
#line 167 "Widgets/gmpc-profiles.vala"
					break;
#line 875 "gmpc-profiles.c"
				}
#line 169 "Widgets/gmpc-profiles.vala"
				_tmp7_ = gmpc_profile_new ();
#line 169 "Widgets/gmpc-profiles.vala"
				prof = _tmp7_;
#line 171 "Widgets/gmpc-profiles.vala"
				_tmp8_ = prof;
#line 171 "Widgets/gmpc-profiles.vala"
				_tmp9_ = iter;
#line 171 "Widgets/gmpc-profiles.vala"
				_tmp10_ = _tmp9_->key;
#line 171 "Widgets/gmpc-profiles.vala"
				_tmp11_ = g_strdup (_tmp10_);
#line 171 "Widgets/gmpc-profiles.vala"
				_g_free0 (_tmp8_->id);
#line 171 "Widgets/gmpc-profiles.vala"
				_tmp8_->id = _tmp11_;
#line 172 "Widgets/gmpc-profiles.vala"
				_tmp12_ = prof;
#line 172 "Widgets/gmpc-profiles.vala"
				_tmp13_ = self->priv->profiles;
#line 172 "Widgets/gmpc-profiles.vala"
				_tmp14_ = prof;
#line 172 "Widgets/gmpc-profiles.vala"
				_tmp15_ = _tmp14_->id;
#line 172 "Widgets/gmpc-profiles.vala"
				_tmp16_ = cfg_get_single_value_as_string (_tmp13_, _tmp15_, "name");
#line 172 "Widgets/gmpc-profiles.vala"
				_g_free0 (_tmp12_->name);
#line 172 "Widgets/gmpc-profiles.vala"
				_tmp12_->name = _tmp16_;
#line 173 "Widgets/gmpc-profiles.vala"
				_tmp17_ = prof;
#line 173 "Widgets/gmpc-profiles.vala"
				_tmp18_ = self->priv->profiles;
#line 173 "Widgets/gmpc-profiles.vala"
				_tmp19_ = prof;
#line 173 "Widgets/gmpc-profiles.vala"
				_tmp20_ = _tmp19_->id;
#line 173 "Widgets/gmpc-profiles.vala"
				_tmp21_ = cfg_get_single_value_as_string (_tmp18_, _tmp20_, "hostname");
#line 173 "Widgets/gmpc-profiles.vala"
				_g_free0 (_tmp17_->hostname);
#line 173 "Widgets/gmpc-profiles.vala"
				_tmp17_->hostname = _tmp21_;
#line 174 "Widgets/gmpc-profiles.vala"
				_tmp22_ = prof;
#line 174 "Widgets/gmpc-profiles.vala"
				_tmp23_ = self->priv->profiles;
#line 174 "Widgets/gmpc-profiles.vala"
				_tmp24_ = prof;
#line 174 "Widgets/gmpc-profiles.vala"
				_tmp25_ = _tmp24_->id;
#line 174 "Widgets/gmpc-profiles.vala"
				_tmp26_ = cfg_get_single_value_as_string (_tmp23_, _tmp25_, "password");
#line 174 "Widgets/gmpc-profiles.vala"
				_g_free0 (_tmp22_->password);
#line 174 "Widgets/gmpc-profiles.vala"
				_tmp22_->password = _tmp26_;
#line 175 "Widgets/gmpc-profiles.vala"
				_tmp27_ = prof;
#line 175 "Widgets/gmpc-profiles.vala"
				_tmp28_ = self->priv->profiles;
#line 175 "Widgets/gmpc-profiles.vala"
				_tmp29_ = prof;
#line 175 "Widgets/gmpc-profiles.vala"
				_tmp30_ = _tmp29_->id;
#line 175 "Widgets/gmpc-profiles.vala"
				_tmp27_->port = cfg_get_single_value_as_int (_tmp28_, _tmp30_, "portnumber");
#line 176 "Widgets/gmpc-profiles.vala"
				_tmp31_ = prof;
#line 176 "Widgets/gmpc-profiles.vala"
				_tmp32_ = self->priv->profiles;
#line 176 "Widgets/gmpc-profiles.vala"
				_tmp33_ = prof;
#line 176 "Widgets/gmpc-profiles.vala"
				_tmp34_ = _tmp33_->id;
#line 176 "Widgets/gmpc-profiles.vala"
				_tmp31_->do_auth = cfg_get_single_value_as_int (_tmp32_, _tmp34_, "useauth");
#line 178 "Widgets/gmpc-profiles.vala"
				_tmp35_ = prof;
#line 178 "Widgets/gmpc-profiles.vala"
				_tmp36_ = self->priv->profiles;
#line 178 "Widgets/gmpc-profiles.vala"
				_tmp37_ = prof;
#line 178 "Widgets/gmpc-profiles.vala"
				_tmp38_ = _tmp37_->id;
#line 178 "Widgets/gmpc-profiles.vala"
				_tmp39_ = cfg_get_single_value_as_string (_tmp36_, _tmp38_, "music directory");
#line 178 "Widgets/gmpc-profiles.vala"
				_g_free0 (_tmp35_->music_directory);
#line 178 "Widgets/gmpc-profiles.vala"
				_tmp35_->music_directory = _tmp39_;
#line 179 "Widgets/gmpc-profiles.vala"
				_tmp40_ = prof;
#line 179 "Widgets/gmpc-profiles.vala"
				_tmp41_ = self->priv->profiles;
#line 179 "Widgets/gmpc-profiles.vala"
				_tmp42_ = prof;
#line 179 "Widgets/gmpc-profiles.vala"
				_tmp43_ = _tmp42_->id;
#line 179 "Widgets/gmpc-profiles.vala"
				_tmp40_->db_update_time = cfg_get_single_value_as_int_with_default (_tmp41_, _tmp43_, "db update time", 0);
#line 181 "Widgets/gmpc-profiles.vala"
				_tmp44_ = self->priv->list;
#line 181 "Widgets/gmpc-profiles.vala"
				_tmp45_ = prof;
#line 181 "Widgets/gmpc-profiles.vala"
				_tmp46_ = _tmp45_->id;
#line 181 "Widgets/gmpc-profiles.vala"
				_tmp47_ = g_strdup (_tmp46_);
#line 181 "Widgets/gmpc-profiles.vala"
				_tmp48_ = prof;
#line 181 "Widgets/gmpc-profiles.vala"
				_tmp49_ = _gmpc_profile_ref0 (_tmp48_);
#line 181 "Widgets/gmpc-profiles.vala"
				g_hash_table_insert (_tmp44_, _tmp47_, _tmp49_);
#line 167 "Widgets/gmpc-profiles.vala"
				_gmpc_profile_unref0 (prof);
#line 995 "gmpc-profiles.c"
			}
		}
	}
#line 162 "Widgets/gmpc-profiles.vala"
	_cfg_free_multiple0 (list);
#line 1001 "gmpc-profiles.c"
}

/**
         * get hostname
         */
gchar*
gmpc_profiles_get_hostname (GmpcProfiles* self,
                            const gchar* id)
{
	GmpcProfile* prof = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GmpcProfile* _tmp2_;
	GmpcProfile* _tmp3_;
	GmpcProfile* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 188 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 188 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 192 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 192 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 192 "Widgets/gmpc-profiles.vala"
	_tmp2_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp1_);
#line 192 "Widgets/gmpc-profiles.vala"
	prof = _tmp2_;
#line 193 "Widgets/gmpc-profiles.vala"
	_tmp3_ = prof;
#line 193 "Widgets/gmpc-profiles.vala"
	if (_tmp3_ == NULL) {
#line 194 "Widgets/gmpc-profiles.vala"
		result = NULL;
#line 194 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 194 "Widgets/gmpc-profiles.vala"
		return result;
#line 1042 "gmpc-profiles.c"
	}
#line 195 "Widgets/gmpc-profiles.vala"
	_tmp4_ = prof;
#line 195 "Widgets/gmpc-profiles.vala"
	_tmp5_ = _tmp4_->hostname;
#line 195 "Widgets/gmpc-profiles.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 195 "Widgets/gmpc-profiles.vala"
	result = _tmp6_;
#line 195 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 195 "Widgets/gmpc-profiles.vala"
	return result;
#line 1056 "gmpc-profiles.c"
}

/**
         * get name
         */
const gchar*
gmpc_profiles_get_name (GmpcProfiles* self,
                        const gchar* id)
{
	GmpcProfile* prof = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GmpcProfile* _tmp2_;
	GmpcProfile* _tmp3_;
	GmpcProfile* _tmp4_;
	const gchar* _tmp5_;
	const gchar* result;
#line 200 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 200 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 204 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 204 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 204 "Widgets/gmpc-profiles.vala"
	_tmp2_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp1_);
#line 204 "Widgets/gmpc-profiles.vala"
	prof = _tmp2_;
#line 205 "Widgets/gmpc-profiles.vala"
	_tmp3_ = prof;
#line 205 "Widgets/gmpc-profiles.vala"
	if (_tmp3_ == NULL) {
#line 206 "Widgets/gmpc-profiles.vala"
		result = NULL;
#line 206 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 206 "Widgets/gmpc-profiles.vala"
		return result;
#line 1096 "gmpc-profiles.c"
	}
#line 207 "Widgets/gmpc-profiles.vala"
	_tmp4_ = prof;
#line 207 "Widgets/gmpc-profiles.vala"
	_tmp5_ = _tmp4_->name;
#line 207 "Widgets/gmpc-profiles.vala"
	result = _tmp5_;
#line 207 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 207 "Widgets/gmpc-profiles.vala"
	return result;
#line 1108 "gmpc-profiles.c"
}

/**
         * get id
         */
const gchar*
gmpc_profiles_get_id (GmpcProfiles* self,
                      const gchar* id)
{
	GmpcProfile* prof = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GmpcProfile* _tmp2_;
	GmpcProfile* _tmp3_;
	GmpcProfile* _tmp4_;
	const gchar* _tmp5_;
	const gchar* result;
#line 212 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 212 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 216 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 216 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 216 "Widgets/gmpc-profiles.vala"
	_tmp2_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp1_);
#line 216 "Widgets/gmpc-profiles.vala"
	prof = _tmp2_;
#line 217 "Widgets/gmpc-profiles.vala"
	_tmp3_ = prof;
#line 217 "Widgets/gmpc-profiles.vala"
	if (_tmp3_ == NULL) {
#line 218 "Widgets/gmpc-profiles.vala"
		result = NULL;
#line 218 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 218 "Widgets/gmpc-profiles.vala"
		return result;
#line 1148 "gmpc-profiles.c"
	}
#line 219 "Widgets/gmpc-profiles.vala"
	_tmp4_ = prof;
#line 219 "Widgets/gmpc-profiles.vala"
	_tmp5_ = _tmp4_->id;
#line 219 "Widgets/gmpc-profiles.vala"
	result = _tmp5_;
#line 219 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 219 "Widgets/gmpc-profiles.vala"
	return result;
#line 1160 "gmpc-profiles.c"
}

/**
         * get password
         */
gchar*
gmpc_profiles_get_password (GmpcProfiles* self,
                            const gchar* id)
{
	GmpcProfile* prof = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GmpcProfile* _tmp2_;
	GmpcProfile* _tmp3_;
	GmpcProfile* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 224 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 224 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 228 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 228 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 228 "Widgets/gmpc-profiles.vala"
	_tmp2_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp1_);
#line 228 "Widgets/gmpc-profiles.vala"
	prof = _tmp2_;
#line 229 "Widgets/gmpc-profiles.vala"
	_tmp3_ = prof;
#line 229 "Widgets/gmpc-profiles.vala"
	if (_tmp3_ == NULL) {
#line 230 "Widgets/gmpc-profiles.vala"
		result = NULL;
#line 230 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 230 "Widgets/gmpc-profiles.vala"
		return result;
#line 1201 "gmpc-profiles.c"
	}
#line 231 "Widgets/gmpc-profiles.vala"
	_tmp4_ = prof;
#line 231 "Widgets/gmpc-profiles.vala"
	_tmp5_ = _tmp4_->password;
#line 231 "Widgets/gmpc-profiles.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 231 "Widgets/gmpc-profiles.vala"
	result = _tmp6_;
#line 231 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 231 "Widgets/gmpc-profiles.vala"
	return result;
#line 1215 "gmpc-profiles.c"
}

/**
         * get music directory
         */
const gchar*
gmpc_profiles_get_music_directory (GmpcProfiles* self,
                                   const gchar* id)
{
	GmpcProfile* prof = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GmpcProfile* _tmp2_;
	GmpcProfile* _tmp3_;
	GmpcProfile* _tmp4_;
	const gchar* _tmp5_;
	const gchar* result;
#line 237 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 237 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 241 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 241 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 241 "Widgets/gmpc-profiles.vala"
	_tmp2_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp1_);
#line 241 "Widgets/gmpc-profiles.vala"
	prof = _tmp2_;
#line 242 "Widgets/gmpc-profiles.vala"
	_tmp3_ = prof;
#line 242 "Widgets/gmpc-profiles.vala"
	if (_tmp3_ == NULL) {
#line 243 "Widgets/gmpc-profiles.vala"
		result = NULL;
#line 243 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 243 "Widgets/gmpc-profiles.vala"
		return result;
#line 1255 "gmpc-profiles.c"
	}
#line 244 "Widgets/gmpc-profiles.vala"
	_tmp4_ = prof;
#line 244 "Widgets/gmpc-profiles.vala"
	_tmp5_ = _tmp4_->music_directory;
#line 244 "Widgets/gmpc-profiles.vala"
	result = _tmp5_;
#line 244 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 244 "Widgets/gmpc-profiles.vala"
	return result;
#line 1267 "gmpc-profiles.c"
}

/**
         * get music directory
         */
gint
gmpc_profiles_get_db_update_time (GmpcProfiles* self,
                                  const gchar* id)
{
	GmpcProfile* prof = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GmpcProfile* _tmp2_;
	GmpcProfile* _tmp3_;
	GmpcProfile* _tmp4_;
	gint result;
#line 249 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 249 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (id != NULL, 0);
#line 253 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 253 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 253 "Widgets/gmpc-profiles.vala"
	_tmp2_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp1_);
#line 253 "Widgets/gmpc-profiles.vala"
	prof = _tmp2_;
#line 254 "Widgets/gmpc-profiles.vala"
	_tmp3_ = prof;
#line 254 "Widgets/gmpc-profiles.vala"
	if (_tmp3_ == NULL) {
#line 255 "Widgets/gmpc-profiles.vala"
		result = 0;
#line 255 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 255 "Widgets/gmpc-profiles.vala"
		return result;
#line 1306 "gmpc-profiles.c"
	}
#line 256 "Widgets/gmpc-profiles.vala"
	_tmp4_ = prof;
#line 256 "Widgets/gmpc-profiles.vala"
	result = _tmp4_->db_update_time;
#line 256 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 256 "Widgets/gmpc-profiles.vala"
	return result;
#line 1316 "gmpc-profiles.c"
}

/**
         * get port
         */
gint
gmpc_profiles_get_port (GmpcProfiles* self,
                        const gchar* id)
{
	GmpcProfile* prof = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GmpcProfile* _tmp2_;
	GmpcProfile* _tmp3_;
	GmpcProfile* _tmp4_;
	gint result;
#line 261 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 261 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (id != NULL, 0);
#line 265 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 265 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 265 "Widgets/gmpc-profiles.vala"
	_tmp2_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp1_);
#line 265 "Widgets/gmpc-profiles.vala"
	prof = _tmp2_;
#line 266 "Widgets/gmpc-profiles.vala"
	_tmp3_ = prof;
#line 266 "Widgets/gmpc-profiles.vala"
	if (_tmp3_ == NULL) {
#line 267 "Widgets/gmpc-profiles.vala"
		result = -1;
#line 267 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 267 "Widgets/gmpc-profiles.vala"
		return result;
#line 1355 "gmpc-profiles.c"
	}
#line 268 "Widgets/gmpc-profiles.vala"
	_tmp4_ = prof;
#line 268 "Widgets/gmpc-profiles.vala"
	result = _tmp4_->port;
#line 268 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 268 "Widgets/gmpc-profiles.vala"
	return result;
#line 1365 "gmpc-profiles.c"
}

/**
         * get do_auth
         */
gboolean
gmpc_profiles_get_do_auth (GmpcProfiles* self,
                           const gchar* id)
{
	GmpcProfile* prof = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GmpcProfile* _tmp2_;
	GmpcProfile* _tmp3_;
	GmpcProfile* _tmp4_;
	gboolean result;
#line 274 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 274 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (id != NULL, FALSE);
#line 278 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 278 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 278 "Widgets/gmpc-profiles.vala"
	_tmp2_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp1_);
#line 278 "Widgets/gmpc-profiles.vala"
	prof = _tmp2_;
#line 279 "Widgets/gmpc-profiles.vala"
	_tmp3_ = prof;
#line 279 "Widgets/gmpc-profiles.vala"
	if (_tmp3_ == NULL) {
#line 280 "Widgets/gmpc-profiles.vala"
		result = FALSE;
#line 280 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 280 "Widgets/gmpc-profiles.vala"
		return result;
#line 1404 "gmpc-profiles.c"
	}
#line 281 "Widgets/gmpc-profiles.vala"
	_tmp4_ = prof;
#line 281 "Widgets/gmpc-profiles.vala"
	result = _tmp4_->do_auth;
#line 281 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 281 "Widgets/gmpc-profiles.vala"
	return result;
#line 1414 "gmpc-profiles.c"
}

/**
        * Create new item
        */
const gchar*
gmpc_profiles_create_new_item (GmpcProfiles* self,
                               const gchar* id)
{
	const gchar* _tmp0_;
	const gchar* result;
#line 287 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 291 "Widgets/gmpc-profiles.vala"
	_tmp0_ = gmpc_profiles_create_new_item_with_name (self, id, "New Profile");
#line 291 "Widgets/gmpc-profiles.vala"
	result = _tmp0_;
#line 291 "Widgets/gmpc-profiles.vala"
	return result;
#line 1434 "gmpc-profiles.c"
}

const gchar*
gmpc_profiles_create_new_item_with_name (GmpcProfiles* self,
                                         const gchar* id,
                                         const gchar* name)
{
	GmpcProfile* prof = NULL;
	GmpcProfile* _tmp0_;
	const config_obj* _tmp9_;
	GmpcProfile* _tmp10_;
	const gchar* _tmp11_;
	GmpcProfile* _tmp12_;
	const gchar* _tmp13_;
	const config_obj* _tmp14_;
	GmpcProfile* _tmp15_;
	const gchar* _tmp16_;
	GmpcProfile* _tmp17_;
	const gchar* _tmp18_;
	const config_obj* _tmp19_;
	GmpcProfile* _tmp20_;
	const gchar* _tmp21_;
	GmpcProfile* _tmp22_;
	const gchar* _tmp23_;
	const config_obj* _tmp24_;
	GmpcProfile* _tmp25_;
	const gchar* _tmp26_;
	GmpcProfile* _tmp27_;
	const config_obj* _tmp28_;
	GmpcProfile* _tmp29_;
	const gchar* _tmp30_;
	GmpcProfile* _tmp31_;
	const config_obj* _tmp32_;
	GmpcProfile* _tmp33_;
	const gchar* _tmp34_;
	GmpcProfile* _tmp35_;
	const gchar* _tmp36_;
	const config_obj* _tmp37_;
	GmpcProfile* _tmp38_;
	const gchar* _tmp39_;
	GmpcProfile* _tmp40_;
	GHashTable* _tmp41_;
	GmpcProfile* _tmp42_;
	const gchar* _tmp43_;
	gchar* _tmp44_;
	GmpcProfile* _tmp45_;
	GmpcProfile* _tmp46_;
	GmpcProfile* _tmp47_;
	const gchar* _tmp48_;
	GmpcProfile* _tmp49_;
	const gchar* _tmp50_;
	const gchar* result;
#line 294 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 298 "Widgets/gmpc-profiles.vala"
	_tmp0_ = gmpc_profile_new ();
#line 298 "Widgets/gmpc-profiles.vala"
	prof = _tmp0_;
#line 299 "Widgets/gmpc-profiles.vala"
	if (id == NULL) {
#line 1495 "gmpc-profiles.c"
		GmpcProfile* _tmp1_;
		gchar* _tmp2_;
#line 300 "Widgets/gmpc-profiles.vala"
		_tmp1_ = prof;
#line 300 "Widgets/gmpc-profiles.vala"
		_tmp2_ = g_strdup_printf ("%u", g_random_int ());
#line 300 "Widgets/gmpc-profiles.vala"
		_g_free0 (_tmp1_->id);
#line 300 "Widgets/gmpc-profiles.vala"
		_tmp1_->id = _tmp2_;
#line 1506 "gmpc-profiles.c"
	} else {
		GmpcProfile* _tmp3_;
		gchar* _tmp4_;
#line 302 "Widgets/gmpc-profiles.vala"
		_tmp3_ = prof;
#line 302 "Widgets/gmpc-profiles.vala"
		_tmp4_ = g_strdup (id);
#line 302 "Widgets/gmpc-profiles.vala"
		_g_free0 (_tmp3_->id);
#line 302 "Widgets/gmpc-profiles.vala"
		_tmp3_->id = _tmp4_;
#line 1518 "gmpc-profiles.c"
	}
#line 303 "Widgets/gmpc-profiles.vala"
	if (name == NULL) {
#line 1522 "gmpc-profiles.c"
		GmpcProfile* _tmp5_;
		gchar* _tmp6_;
#line 304 "Widgets/gmpc-profiles.vala"
		_tmp5_ = prof;
#line 304 "Widgets/gmpc-profiles.vala"
		_tmp6_ = g_strdup ("New Profile");
#line 304 "Widgets/gmpc-profiles.vala"
		_g_free0 (_tmp5_->name);
#line 304 "Widgets/gmpc-profiles.vala"
		_tmp5_->name = _tmp6_;
#line 1533 "gmpc-profiles.c"
	} else {
		GmpcProfile* _tmp7_;
		gchar* _tmp8_;
#line 306 "Widgets/gmpc-profiles.vala"
		_tmp7_ = prof;
#line 306 "Widgets/gmpc-profiles.vala"
		_tmp8_ = g_strdup (name);
#line 306 "Widgets/gmpc-profiles.vala"
		_g_free0 (_tmp7_->name);
#line 306 "Widgets/gmpc-profiles.vala"
		_tmp7_->name = _tmp8_;
#line 1545 "gmpc-profiles.c"
	}
#line 309 "Widgets/gmpc-profiles.vala"
	_tmp9_ = self->priv->profiles;
#line 309 "Widgets/gmpc-profiles.vala"
	_tmp10_ = prof;
#line 309 "Widgets/gmpc-profiles.vala"
	_tmp11_ = _tmp10_->id;
#line 309 "Widgets/gmpc-profiles.vala"
	_tmp12_ = prof;
#line 309 "Widgets/gmpc-profiles.vala"
	_tmp13_ = _tmp12_->name;
#line 309 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_string (_tmp9_, _tmp11_, "name", _tmp13_);
#line 310 "Widgets/gmpc-profiles.vala"
	_tmp14_ = self->priv->profiles;
#line 310 "Widgets/gmpc-profiles.vala"
	_tmp15_ = prof;
#line 310 "Widgets/gmpc-profiles.vala"
	_tmp16_ = _tmp15_->id;
#line 310 "Widgets/gmpc-profiles.vala"
	_tmp17_ = prof;
#line 310 "Widgets/gmpc-profiles.vala"
	_tmp18_ = _tmp17_->hostname;
#line 310 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_string (_tmp14_, _tmp16_, "hostname", _tmp18_);
#line 311 "Widgets/gmpc-profiles.vala"
	_tmp19_ = self->priv->profiles;
#line 311 "Widgets/gmpc-profiles.vala"
	_tmp20_ = prof;
#line 311 "Widgets/gmpc-profiles.vala"
	_tmp21_ = _tmp20_->id;
#line 311 "Widgets/gmpc-profiles.vala"
	_tmp22_ = prof;
#line 311 "Widgets/gmpc-profiles.vala"
	_tmp23_ = _tmp22_->password;
#line 311 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_string (_tmp19_, _tmp21_, "password", _tmp23_);
#line 312 "Widgets/gmpc-profiles.vala"
	_tmp24_ = self->priv->profiles;
#line 312 "Widgets/gmpc-profiles.vala"
	_tmp25_ = prof;
#line 312 "Widgets/gmpc-profiles.vala"
	_tmp26_ = _tmp25_->id;
#line 312 "Widgets/gmpc-profiles.vala"
	_tmp27_ = prof;
#line 312 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_int (_tmp24_, _tmp26_, "portnumber", _tmp27_->port);
#line 313 "Widgets/gmpc-profiles.vala"
	_tmp28_ = self->priv->profiles;
#line 313 "Widgets/gmpc-profiles.vala"
	_tmp29_ = prof;
#line 313 "Widgets/gmpc-profiles.vala"
	_tmp30_ = _tmp29_->id;
#line 313 "Widgets/gmpc-profiles.vala"
	_tmp31_ = prof;
#line 313 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_int (_tmp28_, _tmp30_, "useauth", _tmp31_->do_auth);
#line 314 "Widgets/gmpc-profiles.vala"
	_tmp32_ = self->priv->profiles;
#line 314 "Widgets/gmpc-profiles.vala"
	_tmp33_ = prof;
#line 314 "Widgets/gmpc-profiles.vala"
	_tmp34_ = _tmp33_->id;
#line 314 "Widgets/gmpc-profiles.vala"
	_tmp35_ = prof;
#line 314 "Widgets/gmpc-profiles.vala"
	_tmp36_ = _tmp35_->music_directory;
#line 314 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_string (_tmp32_, _tmp34_, "music directory", _tmp36_);
#line 316 "Widgets/gmpc-profiles.vala"
	_tmp37_ = self->priv->profiles;
#line 316 "Widgets/gmpc-profiles.vala"
	_tmp38_ = prof;
#line 316 "Widgets/gmpc-profiles.vala"
	_tmp39_ = _tmp38_->id;
#line 316 "Widgets/gmpc-profiles.vala"
	_tmp40_ = prof;
#line 316 "Widgets/gmpc-profiles.vala"
	cfg_get_single_value_as_int_with_default (_tmp37_, _tmp39_, "db update time", (gint) _tmp40_->db_update_time);
#line 318 "Widgets/gmpc-profiles.vala"
	_tmp41_ = self->priv->list;
#line 318 "Widgets/gmpc-profiles.vala"
	_tmp42_ = prof;
#line 318 "Widgets/gmpc-profiles.vala"
	_tmp43_ = _tmp42_->id;
#line 318 "Widgets/gmpc-profiles.vala"
	_tmp44_ = g_strdup (_tmp43_);
#line 318 "Widgets/gmpc-profiles.vala"
	_tmp45_ = prof;
#line 318 "Widgets/gmpc-profiles.vala"
	_tmp46_ = _gmpc_profile_ref0 (_tmp45_);
#line 318 "Widgets/gmpc-profiles.vala"
	g_hash_table_insert (_tmp41_, _tmp44_, _tmp46_);
#line 321 "Widgets/gmpc-profiles.vala"
	_tmp47_ = prof;
#line 321 "Widgets/gmpc-profiles.vala"
	_tmp48_ = _tmp47_->id;
#line 321 "Widgets/gmpc-profiles.vala"
	gmpc_profiles_changed_internal (self, GMPC_PROFILES_ACTION_ADDED, GMPC_PROFILES_COLUMN_NUM_COLS, _tmp48_);
#line 322 "Widgets/gmpc-profiles.vala"
	_tmp49_ = prof;
#line 322 "Widgets/gmpc-profiles.vala"
	_tmp50_ = _tmp49_->id;
#line 322 "Widgets/gmpc-profiles.vala"
	result = _tmp50_;
#line 322 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 322 "Widgets/gmpc-profiles.vala"
	return result;
#line 1655 "gmpc-profiles.c"
}

void
gmpc_profiles_remove_item (GmpcProfiles* self,
                           const gchar* id)
{
	gchar* message = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GHashTable* _tmp2_;
	const gchar* _tmp3_;
#line 325 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (self != NULL);
#line 325 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (id != NULL);
#line 329 "Widgets/gmpc-profiles.vala"
	message = NULL;
#line 330 "Widgets/gmpc-profiles.vala"
	if (!gmpc_profiles_has_profile (self, id)) {
#line 332 "Widgets/gmpc-profiles.vala"
		g_log (GMPC_PROFILES_LOG_DOMAIN, G_LOG_LEVEL_WARNING, "gmpc-profiles.vala:332: Trying to remove not-existing profile: %s\n", id);
#line 333 "Widgets/gmpc-profiles.vala"
		_g_free0 (message);
#line 333 "Widgets/gmpc-profiles.vala"
		return;
#line 1681 "gmpc-profiles.c"
	}
#line 336 "Widgets/gmpc-profiles.vala"
	_tmp0_ = gmpc_profiles_get_name (self, id);
#line 336 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_markup_printf_escaped ("<b>%s:</b> '%s'", _ ("Removed profile"), _tmp0_);
#line 336 "Widgets/gmpc-profiles.vala"
	_g_free0 (message);
#line 336 "Widgets/gmpc-profiles.vala"
	message = _tmp1_;
#line 338 "Widgets/gmpc-profiles.vala"
	_tmp2_ = self->priv->list;
#line 338 "Widgets/gmpc-profiles.vala"
	g_hash_table_remove (_tmp2_, id);
#line 341 "Widgets/gmpc-profiles.vala"
	_tmp3_ = message;
#line 341 "Widgets/gmpc-profiles.vala"
	playlist3_show_error_message (_tmp3_, ERROR_INFO);
#line 343 "Widgets/gmpc-profiles.vala"
	gmpc_profiles_changed_internal (self, GMPC_PROFILES_ACTION_REMOVED, GMPC_PROFILES_COLUMN_NUM_COLS, id);
#line 325 "Widgets/gmpc-profiles.vala"
	_g_free0 (message);
#line 1703 "gmpc-profiles.c"
}

/**
        * GET CURRENT
        */
gchar*
gmpc_profiles_get_current (GmpcProfiles* self)
{
	gchar* id = NULL;
	const config_obj* _tmp0_;
	gchar* _tmp1_;
	GmpcProfile* prof = NULL;
	GHashTable* _tmp2_;
	const gchar* _tmp3_;
	gconstpointer _tmp4_;
	GmpcProfile* _tmp5_;
	GmpcProfile* _tmp6_;
	gchar* result;
#line 349 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 353 "Widgets/gmpc-profiles.vala"
	_tmp0_ = config;
#line 353 "Widgets/gmpc-profiles.vala"
	_tmp1_ = cfg_get_single_value_as_string_with_default (_tmp0_, "connection", "currentprofile", "Default");
#line 353 "Widgets/gmpc-profiles.vala"
	id = _tmp1_;
#line 354 "Widgets/gmpc-profiles.vala"
	_tmp2_ = self->priv->list;
#line 354 "Widgets/gmpc-profiles.vala"
	_tmp3_ = id;
#line 354 "Widgets/gmpc-profiles.vala"
	_tmp4_ = g_hash_table_lookup (_tmp2_, _tmp3_);
#line 354 "Widgets/gmpc-profiles.vala"
	_tmp5_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp4_);
#line 354 "Widgets/gmpc-profiles.vala"
	prof = _tmp5_;
#line 356 "Widgets/gmpc-profiles.vala"
	_tmp6_ = prof;
#line 356 "Widgets/gmpc-profiles.vala"
	if (_tmp6_ == NULL) {
#line 1744 "gmpc-profiles.c"
		GHashTable* _tmp7_;
		const config_obj* _tmp14_;
		gchar* _tmp15_;
#line 358 "Widgets/gmpc-profiles.vala"
		_tmp7_ = self->priv->list;
#line 358 "Widgets/gmpc-profiles.vala"
		if (g_hash_table_size (_tmp7_) > ((guint) 0)) {
#line 1752 "gmpc-profiles.c"
			GHashTableIter iter = {0};
			GHashTable* _tmp8_;
			gconstpointer _tmp9_ = NULL;
			gconstpointer _tmp10_ = NULL;
			gchar* _tmp11_;
			GmpcProfile* _tmp12_;
			const gchar* _tmp13_;
#line 360 "Widgets/gmpc-profiles.vala"
			_tmp8_ = self->priv->list;
#line 360 "Widgets/gmpc-profiles.vala"
			g_hash_table_iter_init (&iter, _tmp8_);
#line 361 "Widgets/gmpc-profiles.vala"
			g_hash_table_iter_next (&iter, (gpointer*) (&_tmp9_), (gpointer*) (&_tmp10_));
#line 361 "Widgets/gmpc-profiles.vala"
			_g_free0 (id);
#line 361 "Widgets/gmpc-profiles.vala"
			_tmp11_ = g_strdup ((const gchar*) _tmp9_);
#line 361 "Widgets/gmpc-profiles.vala"
			id = _tmp11_;
#line 361 "Widgets/gmpc-profiles.vala"
			_gmpc_profile_unref0 (prof);
#line 361 "Widgets/gmpc-profiles.vala"
			_tmp12_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp10_);
#line 361 "Widgets/gmpc-profiles.vala"
			prof = _tmp12_;
#line 362 "Widgets/gmpc-profiles.vala"
			_tmp13_ = id;
#line 362 "Widgets/gmpc-profiles.vala"
			gmpc_profiles_set_current (self, _tmp13_);
#line 1782 "gmpc-profiles.c"
		} else {
#line 366 "Widgets/gmpc-profiles.vala"
			gmpc_profiles_add_default (self);
#line 367 "Widgets/gmpc-profiles.vala"
			gmpc_profiles_load_from_config (self);
#line 368 "Widgets/gmpc-profiles.vala"
			gmpc_profiles_changed_internal (self, GMPC_PROFILES_ACTION_ADDED, GMPC_PROFILES_COLUMN_NUM_COLS, "Default");
#line 1790 "gmpc-profiles.c"
		}
#line 370 "Widgets/gmpc-profiles.vala"
		_tmp14_ = config;
#line 370 "Widgets/gmpc-profiles.vala"
		_tmp15_ = cfg_get_single_value_as_string_with_default (_tmp14_, "connection", "currentprofile", "Default");
#line 370 "Widgets/gmpc-profiles.vala"
		_g_free0 (id);
#line 370 "Widgets/gmpc-profiles.vala"
		id = _tmp15_;
#line 1800 "gmpc-profiles.c"
	}
#line 372 "Widgets/gmpc-profiles.vala"
	result = id;
#line 372 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 372 "Widgets/gmpc-profiles.vala"
	return result;
#line 1808 "gmpc-profiles.c"
}

void
gmpc_profiles_set_current (GmpcProfiles* self,
                           const gchar* id)
{
#line 376 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (self != NULL);
#line 376 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (id != NULL);
#line 379 "Widgets/gmpc-profiles.vala"
	if (gmpc_profiles_has_profile (self, id)) {
#line 1821 "gmpc-profiles.c"
		const config_obj* _tmp0_;
#line 381 "Widgets/gmpc-profiles.vala"
		_tmp0_ = config;
#line 381 "Widgets/gmpc-profiles.vala"
		cfg_set_single_value_as_string (_tmp0_, "connection", "currentprofile", id);
#line 383 "Widgets/gmpc-profiles.vala"
		gmpc_profiles_changed_internal (self, GMPC_PROFILES_ACTION_CURRENT, 0, id);
#line 1829 "gmpc-profiles.c"
	}
#line 385 "Widgets/gmpc-profiles.vala"
	g_signal_emit (self, gmpc_profiles_signals[GMPC_PROFILES_PROFILE_CHANGED_SIGNAL], 0, id);
#line 1833 "gmpc-profiles.c"
}

GList*
gmpc_profiles_get_profiles_ids (GmpcProfiles* self)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
	GList* result;
#line 388 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 392 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 392 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
#line 392 "Widgets/gmpc-profiles.vala"
	result = _tmp1_;
#line 392 "Widgets/gmpc-profiles.vala"
	return result;
#line 1852 "gmpc-profiles.c"
}

/**
         * set field
         */
void
gmpc_profiles_set_name (GmpcProfiles* self,
                        const gchar* id,
                        const gchar* value)
{
	GmpcProfile* prof = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GmpcProfile* _tmp2_;
	GmpcProfile* _tmp3_;
	GmpcProfile* _tmp4_;
	const gchar* _tmp5_;
	GmpcProfile* _tmp6_;
	gchar* _tmp7_;
	const config_obj* _tmp8_;
	GmpcProfile* _tmp9_;
	const gchar* _tmp10_;
#line 398 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (self != NULL);
#line 398 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (id != NULL);
#line 398 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (value != NULL);
#line 402 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 402 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 402 "Widgets/gmpc-profiles.vala"
	_tmp2_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp1_);
#line 402 "Widgets/gmpc-profiles.vala"
	prof = _tmp2_;
#line 403 "Widgets/gmpc-profiles.vala"
	_tmp3_ = prof;
#line 403 "Widgets/gmpc-profiles.vala"
	if (_tmp3_ == NULL) {
#line 403 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 403 "Widgets/gmpc-profiles.vala"
		return;
#line 1897 "gmpc-profiles.c"
	}
#line 405 "Widgets/gmpc-profiles.vala"
	_tmp4_ = prof;
#line 405 "Widgets/gmpc-profiles.vala"
	_tmp5_ = _tmp4_->name;
#line 405 "Widgets/gmpc-profiles.vala"
	if (g_strcmp0 (value, _tmp5_) == 0) {
#line 405 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 405 "Widgets/gmpc-profiles.vala"
		return;
#line 1909 "gmpc-profiles.c"
	}
#line 406 "Widgets/gmpc-profiles.vala"
	_tmp6_ = prof;
#line 406 "Widgets/gmpc-profiles.vala"
	_tmp7_ = g_strdup (value);
#line 406 "Widgets/gmpc-profiles.vala"
	_g_free0 (_tmp6_->name);
#line 406 "Widgets/gmpc-profiles.vala"
	_tmp6_->name = _tmp7_;
#line 408 "Widgets/gmpc-profiles.vala"
	_tmp8_ = self->priv->profiles;
#line 408 "Widgets/gmpc-profiles.vala"
	_tmp9_ = prof;
#line 408 "Widgets/gmpc-profiles.vala"
	_tmp10_ = _tmp9_->name;
#line 408 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_string (_tmp8_, id, "name", _tmp10_);
#line 409 "Widgets/gmpc-profiles.vala"
	gmpc_profiles_changed_internal (self, GMPC_PROFILES_ACTION_COL_CHANGED, GMPC_PROFILES_COLUMN_NAME, id);
#line 398 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 1931 "gmpc-profiles.c"
}

void
gmpc_profiles_set_hostname (GmpcProfiles* self,
                            const gchar* id,
                            const gchar* value)
{
	GmpcProfile* prof = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GmpcProfile* _tmp2_;
	GmpcProfile* _tmp3_;
	GmpcProfile* _tmp4_;
	const gchar* _tmp5_;
	GmpcProfile* _tmp6_;
	gchar* _tmp7_;
	const config_obj* _tmp8_;
	GmpcProfile* _tmp9_;
	const gchar* _tmp10_;
#line 412 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (self != NULL);
#line 412 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (id != NULL);
#line 412 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (value != NULL);
#line 416 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 416 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 416 "Widgets/gmpc-profiles.vala"
	_tmp2_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp1_);
#line 416 "Widgets/gmpc-profiles.vala"
	prof = _tmp2_;
#line 417 "Widgets/gmpc-profiles.vala"
	_tmp3_ = prof;
#line 417 "Widgets/gmpc-profiles.vala"
	if (_tmp3_ == NULL) {
#line 417 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 417 "Widgets/gmpc-profiles.vala"
		return;
#line 1973 "gmpc-profiles.c"
	}
#line 419 "Widgets/gmpc-profiles.vala"
	_tmp4_ = prof;
#line 419 "Widgets/gmpc-profiles.vala"
	_tmp5_ = _tmp4_->hostname;
#line 419 "Widgets/gmpc-profiles.vala"
	if (g_strcmp0 (value, _tmp5_) == 0) {
#line 419 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 419 "Widgets/gmpc-profiles.vala"
		return;
#line 1985 "gmpc-profiles.c"
	}
#line 420 "Widgets/gmpc-profiles.vala"
	_tmp6_ = prof;
#line 420 "Widgets/gmpc-profiles.vala"
	_tmp7_ = g_strdup (value);
#line 420 "Widgets/gmpc-profiles.vala"
	_g_free0 (_tmp6_->hostname);
#line 420 "Widgets/gmpc-profiles.vala"
	_tmp6_->hostname = _tmp7_;
#line 422 "Widgets/gmpc-profiles.vala"
	_tmp8_ = self->priv->profiles;
#line 422 "Widgets/gmpc-profiles.vala"
	_tmp9_ = prof;
#line 422 "Widgets/gmpc-profiles.vala"
	_tmp10_ = _tmp9_->hostname;
#line 422 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_string (_tmp8_, id, "hostname", _tmp10_);
#line 423 "Widgets/gmpc-profiles.vala"
	gmpc_profiles_changed_internal (self, GMPC_PROFILES_ACTION_COL_CHANGED, GMPC_PROFILES_COLUMN_HOSTNAME, id);
#line 412 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 2007 "gmpc-profiles.c"
}

/**
         * Set Password
         */
void
gmpc_profiles_set_password (GmpcProfiles* self,
                            const gchar* id,
                            const gchar* value)
{
	GmpcProfile* prof = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GmpcProfile* _tmp2_;
	GmpcProfile* _tmp3_;
	GmpcProfile* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_ = NULL;
	GmpcProfile* _tmp7_;
	gchar* _tmp8_;
	const config_obj* _tmp9_;
	GmpcProfile* _tmp10_;
	const gchar* _tmp11_;
#line 429 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (self != NULL);
#line 429 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (id != NULL);
#line 433 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 433 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 433 "Widgets/gmpc-profiles.vala"
	_tmp2_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp1_);
#line 433 "Widgets/gmpc-profiles.vala"
	prof = _tmp2_;
#line 434 "Widgets/gmpc-profiles.vala"
	_tmp3_ = prof;
#line 434 "Widgets/gmpc-profiles.vala"
	if (_tmp3_ == NULL) {
#line 434 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 434 "Widgets/gmpc-profiles.vala"
		return;
#line 2051 "gmpc-profiles.c"
	}
#line 436 "Widgets/gmpc-profiles.vala"
	_tmp4_ = prof;
#line 436 "Widgets/gmpc-profiles.vala"
	_tmp5_ = _tmp4_->password;
#line 436 "Widgets/gmpc-profiles.vala"
	if (g_strcmp0 (value, _tmp5_) == 0) {
#line 436 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 436 "Widgets/gmpc-profiles.vala"
		return;
#line 2063 "gmpc-profiles.c"
	}
#line 437 "Widgets/gmpc-profiles.vala"
	if (value != NULL) {
#line 437 "Widgets/gmpc-profiles.vala"
		_tmp6_ = value;
#line 2069 "gmpc-profiles.c"
	} else {
#line 437 "Widgets/gmpc-profiles.vala"
		_tmp6_ = "";
#line 2073 "gmpc-profiles.c"
	}
#line 437 "Widgets/gmpc-profiles.vala"
	_tmp7_ = prof;
#line 437 "Widgets/gmpc-profiles.vala"
	_tmp8_ = g_strdup (_tmp6_);
#line 437 "Widgets/gmpc-profiles.vala"
	_g_free0 (_tmp7_->password);
#line 437 "Widgets/gmpc-profiles.vala"
	_tmp7_->password = _tmp8_;
#line 439 "Widgets/gmpc-profiles.vala"
	_tmp9_ = self->priv->profiles;
#line 439 "Widgets/gmpc-profiles.vala"
	_tmp10_ = prof;
#line 439 "Widgets/gmpc-profiles.vala"
	_tmp11_ = _tmp10_->password;
#line 439 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_string (_tmp9_, id, "password", _tmp11_);
#line 440 "Widgets/gmpc-profiles.vala"
	gmpc_profiles_changed_internal (self, GMPC_PROFILES_ACTION_COL_CHANGED, GMPC_PROFILES_COLUMN_PASSWORD, id);
#line 429 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 2095 "gmpc-profiles.c"
}

/**
         * Set Port
         */
void
gmpc_profiles_set_port (GmpcProfiles* self,
                        const gchar* id,
                        gint value)
{
	GmpcProfile* prof = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GmpcProfile* _tmp2_;
	GmpcProfile* _tmp3_;
	GmpcProfile* _tmp4_;
	GmpcProfile* _tmp5_;
	const config_obj* _tmp6_;
	GmpcProfile* _tmp7_;
#line 446 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (self != NULL);
#line 446 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (id != NULL);
#line 450 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 450 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 450 "Widgets/gmpc-profiles.vala"
	_tmp2_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp1_);
#line 450 "Widgets/gmpc-profiles.vala"
	prof = _tmp2_;
#line 451 "Widgets/gmpc-profiles.vala"
	_tmp3_ = prof;
#line 451 "Widgets/gmpc-profiles.vala"
	if (_tmp3_ == NULL) {
#line 451 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 451 "Widgets/gmpc-profiles.vala"
		return;
#line 2135 "gmpc-profiles.c"
	}
#line 453 "Widgets/gmpc-profiles.vala"
	_tmp4_ = prof;
#line 453 "Widgets/gmpc-profiles.vala"
	if (value == _tmp4_->port) {
#line 453 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 453 "Widgets/gmpc-profiles.vala"
		return;
#line 2145 "gmpc-profiles.c"
	}
#line 454 "Widgets/gmpc-profiles.vala"
	_tmp5_ = prof;
#line 454 "Widgets/gmpc-profiles.vala"
	_tmp5_->port = value;
#line 456 "Widgets/gmpc-profiles.vala"
	_tmp6_ = self->priv->profiles;
#line 456 "Widgets/gmpc-profiles.vala"
	_tmp7_ = prof;
#line 456 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_int (_tmp6_, id, "portnumber", _tmp7_->port);
#line 457 "Widgets/gmpc-profiles.vala"
	gmpc_profiles_changed_internal (self, GMPC_PROFILES_ACTION_COL_CHANGED, GMPC_PROFILES_COLUMN_PORT, id);
#line 446 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 2161 "gmpc-profiles.c"
}

/**
         * Set music directory
         */
void
gmpc_profiles_set_music_directory (GmpcProfiles* self,
                                   const gchar* id,
                                   const gchar* value)
{
	GmpcProfile* prof = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GmpcProfile* _tmp2_;
	GmpcProfile* _tmp3_;
	GmpcProfile* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_ = NULL;
	GmpcProfile* _tmp7_;
	gchar* _tmp8_;
	const config_obj* _tmp9_;
	GmpcProfile* _tmp10_;
	const gchar* _tmp11_;
#line 463 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (self != NULL);
#line 463 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (id != NULL);
#line 463 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (value != NULL);
#line 467 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 467 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 467 "Widgets/gmpc-profiles.vala"
	_tmp2_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp1_);
#line 467 "Widgets/gmpc-profiles.vala"
	prof = _tmp2_;
#line 468 "Widgets/gmpc-profiles.vala"
	_tmp3_ = prof;
#line 468 "Widgets/gmpc-profiles.vala"
	if (_tmp3_ == NULL) {
#line 468 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 468 "Widgets/gmpc-profiles.vala"
		return;
#line 2207 "gmpc-profiles.c"
	}
#line 470 "Widgets/gmpc-profiles.vala"
	_tmp4_ = prof;
#line 470 "Widgets/gmpc-profiles.vala"
	_tmp5_ = _tmp4_->music_directory;
#line 470 "Widgets/gmpc-profiles.vala"
	if (g_strcmp0 (value, _tmp5_) == 0) {
#line 470 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 470 "Widgets/gmpc-profiles.vala"
		return;
#line 2219 "gmpc-profiles.c"
	}
#line 471 "Widgets/gmpc-profiles.vala"
	if (value != NULL) {
#line 471 "Widgets/gmpc-profiles.vala"
		_tmp6_ = value;
#line 2225 "gmpc-profiles.c"
	} else {
#line 471 "Widgets/gmpc-profiles.vala"
		_tmp6_ = "";
#line 2229 "gmpc-profiles.c"
	}
#line 471 "Widgets/gmpc-profiles.vala"
	_tmp7_ = prof;
#line 471 "Widgets/gmpc-profiles.vala"
	_tmp8_ = g_strdup (_tmp6_);
#line 471 "Widgets/gmpc-profiles.vala"
	_g_free0 (_tmp7_->music_directory);
#line 471 "Widgets/gmpc-profiles.vala"
	_tmp7_->music_directory = _tmp8_;
#line 473 "Widgets/gmpc-profiles.vala"
	_tmp9_ = self->priv->profiles;
#line 473 "Widgets/gmpc-profiles.vala"
	_tmp10_ = prof;
#line 473 "Widgets/gmpc-profiles.vala"
	_tmp11_ = _tmp10_->music_directory;
#line 473 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_string (_tmp9_, id, "music directory", _tmp11_);
#line 474 "Widgets/gmpc-profiles.vala"
	gmpc_profiles_changed_internal (self, GMPC_PROFILES_ACTION_COL_CHANGED, GMPC_PROFILES_COLUMN_MUSIC_DIRECTORY, id);
#line 463 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 2251 "gmpc-profiles.c"
}

void
gmpc_profiles_set_db_update_time (GmpcProfiles* self,
                                  const gchar* id,
                                  gint value)
{
	GmpcProfile* prof = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GmpcProfile* _tmp2_;
	GmpcProfile* _tmp3_;
	GmpcProfile* _tmp4_;
	GmpcProfile* _tmp5_;
	const config_obj* _tmp6_;
#line 478 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (self != NULL);
#line 478 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (id != NULL);
#line 482 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 482 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 482 "Widgets/gmpc-profiles.vala"
	_tmp2_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp1_);
#line 482 "Widgets/gmpc-profiles.vala"
	prof = _tmp2_;
#line 483 "Widgets/gmpc-profiles.vala"
	_tmp3_ = prof;
#line 483 "Widgets/gmpc-profiles.vala"
	if (_tmp3_ == NULL) {
#line 483 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 483 "Widgets/gmpc-profiles.vala"
		return;
#line 2287 "gmpc-profiles.c"
	}
#line 485 "Widgets/gmpc-profiles.vala"
	_tmp4_ = prof;
#line 485 "Widgets/gmpc-profiles.vala"
	if (value == _tmp4_->db_update_time) {
#line 485 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 485 "Widgets/gmpc-profiles.vala"
		return;
#line 2297 "gmpc-profiles.c"
	}
#line 486 "Widgets/gmpc-profiles.vala"
	_tmp5_ = prof;
#line 486 "Widgets/gmpc-profiles.vala"
	_tmp5_->db_update_time = value;
#line 488 "Widgets/gmpc-profiles.vala"
	_tmp6_ = self->priv->profiles;
#line 488 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_int (_tmp6_, id, "db update time", value);
#line 489 "Widgets/gmpc-profiles.vala"
	gmpc_profiles_changed_internal (self, GMPC_PROFILES_ACTION_COL_CHANGED, GMPC_PROFILES_COLUMN_DB_UPDATE_TIME, id);
#line 478 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 2311 "gmpc-profiles.c"
}

/**
         * Set do auth
         */
void
gmpc_profiles_set_do_auth (GmpcProfiles* self,
                           const gchar* id,
                           gboolean value)
{
	GmpcProfile* prof = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GmpcProfile* _tmp2_;
	GmpcProfile* _tmp3_;
	GmpcProfile* _tmp4_;
	GmpcProfile* _tmp5_;
	const config_obj* _tmp6_;
	GmpcProfile* _tmp7_;
#line 495 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (self != NULL);
#line 495 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (id != NULL);
#line 499 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 499 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 499 "Widgets/gmpc-profiles.vala"
	_tmp2_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp1_);
#line 499 "Widgets/gmpc-profiles.vala"
	prof = _tmp2_;
#line 500 "Widgets/gmpc-profiles.vala"
	_tmp3_ = prof;
#line 500 "Widgets/gmpc-profiles.vala"
	if (_tmp3_ == NULL) {
#line 500 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 500 "Widgets/gmpc-profiles.vala"
		return;
#line 2351 "gmpc-profiles.c"
	}
#line 502 "Widgets/gmpc-profiles.vala"
	_tmp4_ = prof;
#line 502 "Widgets/gmpc-profiles.vala"
	if (_tmp4_->do_auth == value) {
#line 502 "Widgets/gmpc-profiles.vala"
		_gmpc_profile_unref0 (prof);
#line 502 "Widgets/gmpc-profiles.vala"
		return;
#line 2361 "gmpc-profiles.c"
	}
#line 503 "Widgets/gmpc-profiles.vala"
	_tmp5_ = prof;
#line 503 "Widgets/gmpc-profiles.vala"
	_tmp5_->do_auth = value;
#line 505 "Widgets/gmpc-profiles.vala"
	_tmp6_ = self->priv->profiles;
#line 505 "Widgets/gmpc-profiles.vala"
	_tmp7_ = prof;
#line 505 "Widgets/gmpc-profiles.vala"
	cfg_set_single_value_as_int (_tmp6_, id, "useauth", _tmp7_->do_auth);
#line 506 "Widgets/gmpc-profiles.vala"
	gmpc_profiles_changed_internal (self, GMPC_PROFILES_ACTION_COL_CHANGED, GMPC_PROFILES_COLUMN_DO_AUTH, id);
#line 495 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 2377 "gmpc-profiles.c"
}

/**
         * Has profile with id
         */
gboolean
gmpc_profiles_has_profile (GmpcProfiles* self,
                           const gchar* id)
{
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	gboolean result;
#line 512 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 512 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (id != NULL, FALSE);
#line 516 "Widgets/gmpc-profiles.vala"
	_tmp0_ = self->priv->list;
#line 516 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 516 "Widgets/gmpc-profiles.vala"
	result = ((GmpcProfile*) _tmp1_) != NULL;
#line 516 "Widgets/gmpc-profiles.vala"
	return result;
#line 2402 "gmpc-profiles.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 519 "Widgets/gmpc-profiles.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 519 "Widgets/gmpc-profiles.vala"
	return _data7_;
#line 2412 "gmpc-profiles.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 519 "Widgets/gmpc-profiles.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 2422 "gmpc-profiles.c"
		GmpcProfiles* self;
#line 519 "Widgets/gmpc-profiles.vala"
		self = _data7_->self;
#line 519 "Widgets/gmpc-profiles.vala"
		_g_free0 (_data7_->name);
#line 519 "Widgets/gmpc-profiles.vala"
		_g_object_unref0 (self);
#line 519 "Widgets/gmpc-profiles.vala"
		g_slice_free (Block7Data, _data7_);
#line 2432 "gmpc-profiles.c"
	}
}

static gboolean
__lambda85_ (Block7Data* _data7_,
             const gchar* id,
             GmpcProfile* prof)
{
	GmpcProfiles* self;
	const gchar* _tmp0_;
	gboolean result;
#line 523 "Widgets/gmpc-profiles.vala"
	self = _data7_->self;
#line 523 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (id != NULL, FALSE);
#line 523 "Widgets/gmpc-profiles.vala"
	g_return_val_if_fail (prof != NULL, FALSE);
#line 525 "Widgets/gmpc-profiles.vala"
	_tmp0_ = prof->name;
#line 525 "Widgets/gmpc-profiles.vala"
	result = g_strcmp0 (_data7_->name, _tmp0_) == 0;
#line 525 "Widgets/gmpc-profiles.vala"
	return result;
#line 2456 "gmpc-profiles.c"
}

static gboolean
___lambda85__ghr_func (gconstpointer key,
                       gconstpointer value,
                       gpointer self)
{
	gboolean result;
	result = __lambda85_ (self, (const gchar*) key, (GmpcProfile*) value);
#line 523 "Widgets/gmpc-profiles.vala"
	return result;
#line 2468 "gmpc-profiles.c"
}

void
gmpc_profiles_set_profile_from_name (GmpcProfiles* self,
                                     const gchar* name)
{
	Block7Data* _data7_;
	gchar* _tmp0_;
	GmpcProfile* prof = NULL;
	GHashTable* _tmp1_;
	gconstpointer _tmp2_;
	GmpcProfile* _tmp3_;
	const gchar* _tmp4_;
#line 519 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (self != NULL);
#line 519 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (name != NULL);
#line 519 "Widgets/gmpc-profiles.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 519 "Widgets/gmpc-profiles.vala"
	_data7_->_ref_count_ = 1;
#line 519 "Widgets/gmpc-profiles.vala"
	_data7_->self = g_object_ref (self);
#line 519 "Widgets/gmpc-profiles.vala"
	_tmp0_ = g_strdup (name);
#line 519 "Widgets/gmpc-profiles.vala"
	_g_free0 (_data7_->name);
#line 519 "Widgets/gmpc-profiles.vala"
	_data7_->name = _tmp0_;
#line 523 "Widgets/gmpc-profiles.vala"
	_tmp1_ = self->priv->list;
#line 523 "Widgets/gmpc-profiles.vala"
	_tmp2_ = g_hash_table_find (_tmp1_, ___lambda85__ghr_func, _data7_);
#line 523 "Widgets/gmpc-profiles.vala"
	_tmp3_ = _gmpc_profile_ref0 ((GmpcProfile*) _tmp2_);
#line 523 "Widgets/gmpc-profiles.vala"
	prof = _tmp3_;
#line 527 "Widgets/gmpc-profiles.vala"
	_tmp4_ = prof->id;
#line 527 "Widgets/gmpc-profiles.vala"
	connection_set_current_profile (_tmp4_);
#line 519 "Widgets/gmpc-profiles.vala"
	_gmpc_profile_unref0 (prof);
#line 519 "Widgets/gmpc-profiles.vala"
	block7_data_unref (_data7_);
#line 519 "Widgets/gmpc-profiles.vala"
	_data7_ = NULL;
#line 2516 "gmpc-profiles.c"
}

GmpcProfiles*
gmpc_profiles_construct (GType object_type)
{
	GmpcProfiles * self = NULL;
#line 37 "Widgets/gmpc-profiles.vala"
	self = (GmpcProfiles*) g_object_new (object_type, NULL);
#line 37 "Widgets/gmpc-profiles.vala"
	return self;
#line 2527 "gmpc-profiles.c"
}

GmpcProfiles*
gmpc_profiles_new (void)
{
#line 37 "Widgets/gmpc-profiles.vala"
	return gmpc_profiles_construct (GMPC_TYPE_PROFILES);
#line 2535 "gmpc-profiles.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT_STRING (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_STRING) (gpointer data1, gint arg_1, gint arg_2, const char* arg_3, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 37 "Widgets/gmpc-profiles.vala"
	g_return_if_fail (n_param_values == 4);
#line 37 "Widgets/gmpc-profiles.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 37 "Widgets/gmpc-profiles.vala"
		data1 = closure->data;
#line 37 "Widgets/gmpc-profiles.vala"
		data2 = param_values->data[0].v_pointer;
#line 2560 "gmpc-profiles.c"
	} else {
#line 37 "Widgets/gmpc-profiles.vala"
		data1 = param_values->data[0].v_pointer;
#line 37 "Widgets/gmpc-profiles.vala"
		data2 = closure->data;
#line 2566 "gmpc-profiles.c"
	}
#line 37 "Widgets/gmpc-profiles.vala"
	callback = (GMarshalFunc_VOID__INT_INT_STRING) (marshal_data ? marshal_data : cc->callback);
#line 37 "Widgets/gmpc-profiles.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_string (param_values + 3), data2);
#line 2572 "gmpc-profiles.c"
}

static void
_g_free0_ (gpointer var)
{
#line 124 "Widgets/gmpc-profiles.vala"
	var = (g_free (var), NULL);
#line 2580 "gmpc-profiles.c"
}

static void
_gmpc_profile_unref0_ (gpointer var)
{
#line 124 "Widgets/gmpc-profiles.vala"
	(var == NULL) ? NULL : (var = (gmpc_profile_unref (var), NULL));
#line 2588 "gmpc-profiles.c"
}

static GObject *
gmpc_profiles_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GmpcProfiles * self;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	gchar* url = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	config_obj* _tmp5_;
	const config_obj* _tmp6_;
	GHashTable* _tmp8_;
#line 122 "Widgets/gmpc-profiles.vala"
	parent_class = G_OBJECT_CLASS (gmpc_profiles_parent_class);
#line 122 "Widgets/gmpc-profiles.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 122 "Widgets/gmpc-profiles.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GMPC_TYPE_PROFILES, GmpcProfiles);
#line 124 "Widgets/gmpc-profiles.vala"
	_tmp0_ = g_str_hash;
#line 124 "Widgets/gmpc-profiles.vala"
	_tmp1_ = g_str_equal;
#line 124 "Widgets/gmpc-profiles.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _gmpc_profile_unref0_);
#line 124 "Widgets/gmpc-profiles.vala"
	_g_hash_table_unref0 (self->priv->list);
#line 124 "Widgets/gmpc-profiles.vala"
	self->priv->list = _tmp2_;
#line 129 "Widgets/gmpc-profiles.vala"
	_tmp3_ = gmpc_get_user_path ("profiles.cfg");
#line 129 "Widgets/gmpc-profiles.vala"
	_g_free0 (url);
#line 129 "Widgets/gmpc-profiles.vala"
	url = _tmp3_;
#line 130 "Widgets/gmpc-profiles.vala"
	_tmp4_ = url;
#line 130 "Widgets/gmpc-profiles.vala"
	_tmp5_ = cfg_open (_tmp4_);
#line 130 "Widgets/gmpc-profiles.vala"
	_cfg_close0 (self->priv->profiles);
#line 130 "Widgets/gmpc-profiles.vala"
	self->priv->profiles = _tmp5_;
#line 131 "Widgets/gmpc-profiles.vala"
	_tmp6_ = self->priv->profiles;
#line 131 "Widgets/gmpc-profiles.vala"
	if (_tmp6_ == NULL) {
#line 2642 "gmpc-profiles.c"
		const gchar* _tmp7_;
#line 136 "Widgets/gmpc-profiles.vala"
		_tmp7_ = url;
#line 136 "Widgets/gmpc-profiles.vala"
		g_log (GMPC_PROFILES_LOG_DOMAIN, G_LOG_LEVEL_ERROR, "gmpc-profiles.vala:136: Failed to save/load Profile file:\n%s\n", _tmp7_);
#line 2648 "gmpc-profiles.c"
	}
#line 138 "Widgets/gmpc-profiles.vala"
	gmpc_profiles_load_from_config (self);
#line 139 "Widgets/gmpc-profiles.vala"
	_tmp8_ = self->priv->list;
#line 139 "Widgets/gmpc-profiles.vala"
	if (g_hash_table_size (_tmp8_) == ((guint) 0)) {
#line 141 "Widgets/gmpc-profiles.vala"
		gmpc_profiles_add_default (self);
#line 142 "Widgets/gmpc-profiles.vala"
		gmpc_profiles_load_from_config (self);
#line 2660 "gmpc-profiles.c"
	}
#line 122 "Widgets/gmpc-profiles.vala"
	_g_free0 (url);
#line 122 "Widgets/gmpc-profiles.vala"
	return obj;
#line 2666 "gmpc-profiles.c"
}

static void
gmpc_profiles_class_init (GmpcProfilesClass * klass,
                          gpointer klass_data)
{
#line 37 "Widgets/gmpc-profiles.vala"
	gmpc_profiles_parent_class = g_type_class_peek_parent (klass);
#line 37 "Widgets/gmpc-profiles.vala"
	g_type_class_adjust_private_offset (klass, &GmpcProfiles_private_offset);
#line 37 "Widgets/gmpc-profiles.vala"
	G_OBJECT_CLASS (klass)->constructor = gmpc_profiles_constructor;
#line 37 "Widgets/gmpc-profiles.vala"
	G_OBJECT_CLASS (klass)->finalize = gmpc_profiles_finalize;
#line 37 "Widgets/gmpc-profiles.vala"
	gmpc_profiles_signals[GMPC_PROFILES_CHANGED_SIGNAL] = g_signal_new ("changed", GMPC_TYPE_PROFILES, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_STRING, G_TYPE_NONE, 3, G_TYPE_INT, G_TYPE_INT, G_TYPE_STRING);
#line 37 "Widgets/gmpc-profiles.vala"
	gmpc_profiles_signals[GMPC_PROFILES_PROFILE_CHANGED_SIGNAL] = g_signal_new ("profile-changed", GMPC_TYPE_PROFILES, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 2685 "gmpc-profiles.c"
}

static void
gmpc_profiles_instance_init (GmpcProfiles * self,
                             gpointer klass)
{
#line 37 "Widgets/gmpc-profiles.vala"
	self->priv = gmpc_profiles_get_instance_private (self);
#line 2694 "gmpc-profiles.c"
}

static void
gmpc_profiles_finalize (GObject * obj)
{
	GmpcProfiles * self;
#line 37 "Widgets/gmpc-profiles.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GMPC_TYPE_PROFILES, GmpcProfiles);
#line 61 "Widgets/gmpc-profiles.vala"
	_cfg_close0 (self->priv->profiles);
#line 62 "Widgets/gmpc-profiles.vala"
	_g_hash_table_unref0 (self->priv->list);
#line 37 "Widgets/gmpc-profiles.vala"
	G_OBJECT_CLASS (gmpc_profiles_parent_class)->finalize (obj);
#line 2709 "gmpc-profiles.c"
}

static GType
gmpc_profiles_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GmpcProfilesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gmpc_profiles_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GmpcProfiles), 0, (GInstanceInitFunc) gmpc_profiles_instance_init, NULL };
	GType gmpc_profiles_type_id;
	gmpc_profiles_type_id = g_type_register_static (G_TYPE_OBJECT, "GmpcProfiles", &g_define_type_info, 0);
	GmpcProfiles_private_offset = g_type_add_instance_private (gmpc_profiles_type_id, sizeof (GmpcProfilesPrivate));
	return gmpc_profiles_type_id;
}

GType
gmpc_profiles_get_type (void)
{
	static volatile gsize gmpc_profiles_type_id__once = 0;
	if (g_once_init_enter (&gmpc_profiles_type_id__once)) {
		GType gmpc_profiles_type_id;
		gmpc_profiles_type_id = gmpc_profiles_get_type_once ();
		g_once_init_leave (&gmpc_profiles_type_id__once, gmpc_profiles_type_id);
	}
	return gmpc_profiles_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

